

import * as dzsHelpers from '../../inc/js/_admin_helpers';
import {$es} from '../../inc/js/_esjquery'

export function init_userPoints(){

  let debounceUserPoints = null;

  $es(document).on('click', '.user-points--points-amount--increase,.user-points--points-amount--decrease', handleMouse);
  $es(document).on('keyup', '.dzspsy-user-points', handleInput);
  setTimeout(()=>{

    $es('.dzspsy-user-points').trigger('keyup');
  },300);

  function handleMouse(){

    var $t = $es(this);
    var $par = $t.parent().parent(); // -- <tr>
    if($t.hasClass('user-points--points-amount--decrease') || $t.hasClass('user-points--points-amount--increase')){

      dzsHelpers.dzs_show_notice({success: true, status: 'success', data: { message: 'loading...'}});


      var data = {
        action: 'dzspsy_user_points_admin_change',
        increase_type: 'increase',
        user_id: $par.attr('data-user-id'),
        points_amount: $par.find('.user-points--points-amount').val()
      }

      if($t.hasClass('user-points--points-amount--decrease')){
        data.increase_type = 'decrease';
      }

      es_ajax({
        url: ajaxurl,
        method: 'POST',
        data,
        success: function(e, respObj){

          var resp = dzsHelpers.parse_response(respObj.responseText);
          dzsHelpers.dzs_show_notice(resp);
        },
        error: function(e, respObj){

          var resp = dzsHelpers.parse_response(respObj.responseText);
          dzsHelpers.dzs_show_notice(resp);
        }
      })
    }
  }
  function handleInput(){
    var $t = $es(this);

    if($t.hasClass('dzspsy-user-points')){

      if(debounceUserPoints){
        clearTimeout(debounceUserPoints);
      }

      debounceUserPoints = setTimeout(()=>{

        let userSearchUriQuery = ajaxurl;

        var data = {
          action: 'dzspsy_user_points_table',
          user_search: $t.val()
        }
        Object.keys(data).forEach((dataKey)=>{
          let dataVal = data[dataKey];
          userSearchUriQuery = window.add_query_arg(userSearchUriQuery, dataKey, dataVal);
        })
        es_ajax({
          url: userSearchUriQuery,
          method: 'GET',
          data,
          success: function(e, respObj){

            var resp = dzsHelpers.parse_response(respObj.responseText);
            if(typeof resp==='object'){
              $es('.dzspsy-user-points-table').html(resp.htmlOutput);
            }
          }
        })
      },200);

    }
  }
}