<?php


include_once DZSPSY_PATH . 'inc/php/woocommerce_actions.php';
include_once DZSPSY_PATH . 'inc/php/buddypress.php';
include_once DZSPSY_PATH . 'inc/php/DzspsyAjax.php';
include_once DZSPSY_PATH . 'inc/php/DzspsyPages.php';
include_once DZSPSY_PATH . 'inc/php/DzspsyHelpers.php';
include_once DZSPSY_PATH . 'inc/php/DzspsyView.php';
include_once DZSPSY_PATH . 'inc/php/DzspsyDb.php';
include_once DZSPSY_PATH . 'inc/php/DzspsyWooCommerce.php';
include_once DZSPSY_PATH . 'inc/php/common/dzscommon-validators.php';

class DZSPointSystem {

  public $dzspsy_point_vars = array();
  public $current_user_points = 0;

  public $db_mainoptions = array();

  public $classAjax = null;
  public $classView = null;
  public $classPages = null;
  public $classDb = null;
  public $classWoocommerce = null;

  function __construct() {

    add_action('init', array($this, 'handle_init_start'), 3);
    add_action('admin_head', array($this, 'handle_admin_head'), 900);


    dzspsy_buddypress_init_actions();


    $this->classView = new DzspsyView($this);
    $this->classDb = new DzspsyDb($this);
    $this->classWoocommerce = new DzspsyWooCommerce($this);
    $this->classAjax = new DzspsyAjax($this);

    $this->classWoocommerce->init_actions();

    $aux = get_option('dzspsy_point_vars');
    if ($aux) {
      $this->dzspsy_point_vars = json_decode($aux, true);
    }
  }

  function handle_activate() {
    $role = get_role('administrator');
    $role->add_cap(DZSPSY_CAPABILITY_ADMIN_PAGE);
  }

  function handle_init_start() {

    function returnConfigOptionDefault($configOption) {
      return $configOption['default'];
    }


    $tryToGetCurrentUserId = DzspsyDb::tryToGetCurrentUserId();
    if ($tryToGetCurrentUserId) {
      $this->classDb->currentUserId = $tryToGetCurrentUserId;
    }

    $this->db_mainoptions = (get_option(DZSPSY_DBNAME_MAIN_OPTIONS));
    try {
      $dbOptions = json_decode($this->db_mainoptions, true);

      if (!$dbOptions) {
        $dbOptions = array();
      }


      $config_main_options = include DZSPSY_PATH . 'configs/config-main-options.php';

      $defaultOptions = array_map('returnConfigOptionDefault', $config_main_options);
      $this->db_mainoptions = array_merge($defaultOptions, $dbOptions);
    } catch (Exception $e) {
      print_rr($e);
    };


    if (is_admin()) {

      $this->classPages = new DzspsyPages($this);
    }
  }

  function handle_admin_head() {

    wp_enqueue_style('dzspsy-admin-global', DZSPSY_URL . 'admin/admin-global.css');
  }


}
