<?php


class DzspsyHelpers {

  function __construct() {
  }

  /**
   * @param $pargs  <pre>array(
  'type' => null,
  'user_id' => null,
  'order_id' => null,
  'membership_package_id' => null,
  'date' => null,
  'action_source' => null,
  'amount' => null,
  )</pre>
   * @return string
   */
  static function admin_generateLogTextForEntry($pargs){

    $margs = array(
      'type' => null,
      'user_id' => null,
      'order_id' => null,
      'membership_package_id' => null,
      'date' => null,
      'action_source' => null,
      'amount' => null,
    );
    $margs = array_merge($margs, $pargs);


    $fout = '';

    $userAffected = get_user_by('id', $margs['user_id']);

    if($margs['action_source']===DZSPSY_LOGGING__ACTION_SOURCE['USER']){

      $fout.=esc_html__('User', DZSPSY_ID).' <strong>'.$userAffected->display_name.'</strong> ';

      if($margs['type']===DZSPSY_POINTS_INCREASE_TYPES['INCREASE']){
        $fout.=esc_html__('increased', DZSPSY_ID).' ';
      }
      if($margs['type']===DZSPSY_POINTS_INCREASE_TYPES['DECREASE']){
        $fout.=esc_html__('spent', DZSPSY_ID).' ';
      }
      $fout.=esc_html__('points by', DZSPSY_ID).' ';
      $fout.=' <strong>'.$margs['amount'].'</strong> ';

      if($margs['type']===DZSPSY_POINTS_INCREASE_TYPES['DECREASE']){

        $fout.=esc_html__('by purchasing order ', DZSPSY_ID).' ';



        if(current_user_can(DZSPSY_PERMISSIONS_CAN_EDIT_ORDERS)){
          $fout.='<a target="_blank" href="'.admin_url('post.php?post='.$margs['order_id'].'&action=edit').'">';
        }
        $fout.='<strong>#'.$margs['order_id'].'</strong> ';
        if(current_user_can(DZSPSY_PERMISSIONS_CAN_EDIT_ORDERS)){
          $fout.='</a>';
        }
      }

    }

    if($margs['action_source']===DZSPSY_LOGGING__ACTION_SOURCE['ADMIN']){
      $fout.=esc_html__('Admin modified user', DZSPSY_ID).' <strong>'.$userAffected->display_name.'</strong> ';
      $fout.=esc_html__('by', DZSPSY_ID).' ';

      if($margs['type']===DZSPSY_POINTS_INCREASE_TYPES['INCREASE']){
        $fout.=esc_html__('increasing', DZSPSY_ID).' ';
      }
      if($margs['type']===DZSPSY_POINTS_INCREASE_TYPES['DECREASE']){
        $fout.=esc_html__('decreasing', DZSPSY_ID).' ';
      }
      $fout.=esc_html__('points by', DZSPSY_ID).' ';
      $fout.=' <strong>'.$margs['amount'].'</strong> ';
    }


    return $fout;
  }

  static function generateOptionsFromConfigForMainOptions($config_main_options, $category = 'main') {

    global $dzspsy;

    $fout = '';
    foreach ($config_main_options as $key => $main_option) {
      if ($main_option['category'] !== $category) {
        continue;
      }

      $lab = $key;


      $val = '';

      if (isset($main_option['default']) && $main_option['default']) {
        $val = $main_option['default'];
      }

      if (is_array($dzspsy->db_mainoptions) && isset($dzspsy->db_mainoptions[$lab]) && $dzspsy->db_mainoptions[$lab]) {
        $val = $dzspsy->db_mainoptions[$lab];
      }


      $fout .= '<div class="setting">';
      $fout .= '<h4 class="setting-label">' . $main_option['title'] . '</h4>';

      $argsForInput = array(
        'id' => $lab,
        'val' => '',
        'class' => ' ',
        'seekval' => $val,
      );

      if ($main_option['type'] == 'textarea') {
        $fout .= DZSHelpers::generate_input_textarea($lab, $argsForInput);
      }
      if ($main_option['type'] == 'text') {
        $fout .= DZSHelpers::generate_input_text($lab, $argsForInput);
      }
      if ($main_option['type'] == 'select') {
        $argsForInput['class'] = 'dzs-style-me skin-beige ';
        $argsForInput['options'] = $main_option['choices'];
        $fout .= DZSHelpers::generate_select($lab, $argsForInput);
      }
      if ($main_option['type'] == 'checkbox') {
        $fout .= DZSHelpers::generate_input_text($lab, array('id' => $lab, 'val' => 'off', 'input_type' => 'hidden'));
        $fout .= '<div class="dzscheckbox skin-nova">';
        $fout .= DZSHelpers::generate_input_checkbox($lab, array('id' => $lab, 'val' => 'on', 'seekval' => $val));
        $fout .= '<label for="' . $lab . '"></label>';
        $fout .= '</div>';
      }
      if ($main_option['type'] == 'checkboxes') {
        $fout .= '<div class="dzs-checkbox-selector skin-nova">';


        foreach ($main_option['choices'] as $choice) {
          $seekval = '';

          if(is_array($val) && in_array($choice['value'], $val)){
            $seekval = $choice['value'];
          }

          $fout .= '<label>';
          $fout .= DZSHelpers::generate_input_checkbox($lab.'[]', array('val' => $choice['value'], 'seekval' => $seekval));
          $fout .= '<span class="the-label"><span class="the-text">' . $choice['label'] . '</span></span></label>';
        }
        $fout .= '</div>';
      }
      if (isset($main_option['sidenote']) && $main_option['sidenote']) {
        $fout .= '<div class="sidenote">' . $main_option['sidenote'] . '</div>';
      }

      $fout .= '</div>';


    }
    return $fout;

  }


}