<?php


function dzspsy_buddypress_init_actions(){

  add_action('bp_before_profile_loop_content', 'dzspsy_buddypress_add_points_to_profile');
}

function dzspsy_buddypress_add_points_to_profile() {
  global $dzspsy, $bp;

  $int_points = 0;

  $displayedUserId = 0;

  if($bp->displayed_user && $bp->displayed_user->id){
    $displayedUserId = $bp->displayed_user->id;
  }



  if($displayedUserId){

    $user_points = get_user_meta($displayedUserId, DZSPSY_USERMETA_POINTS_VAR, true);
    if (intval($user_points)) {
      $int_points = intval($user_points);
    }
    ?><br><br><h3 class="screen-heading profile-group-title"><?php echo esc_html__('Points', 'dzspsy'); ?></h3>
    <table class="profile-fields bp-tables-user">



    <tbody>
    <tr class="field_1 field_name required-field visibility-public field_type_textbox">

      <td class="label"><?php echo esc_html__("Remaining", DZSPSY_ID); ?></td>

      <td class="data"><span><?php echo $int_points; ?></span>
      </td>

    </tr>
    </tbody></table><?php


    $points_history = $dzspsy->classDb->get_points_history();
    if (is_array($points_history) && count($points_history)) {

      ?>
      <table class="profile-fields bp-tables-user">
      <thead style="font-style: italic; font-size: 11px;">
      <td>&bkarow; <?php echo esc_html__("history", 'dzspsy'); ?></td>
      <td><?php echo esc_html__("date", 'dzspsy'); ?></td>
      <td><?php echo esc_html__("type", 'dzspsy'); ?></td>
      <td><?php echo esc_html__("amount", 'dzspsy'); ?></td>
      </thead>
      <tbody>
      <?php foreach ($points_history as $lab => $tr) {
        $title = '';
        if (isset($tr['title'])) {
          $title = $tr['title'];
        }

        $title = DzspsyHelpers::admin_generateLogTextForEntry(array(
          'type'=>$tr['type'],
          'user_id'=>$displayedUserId,
          'order_id'=>$tr['order_id'],
          'date'=>$tr['date'],
          'action_source'=>$tr['action_source'],
          'amount'=>$tr['amount'],
        ))
        ?>
        <tr class="field_1 field_name required-field visibility-public field_type_textbox">

        <td class="label"
            style=" ;  ; max-width: 300px; text-overflow: ellipsis;"><?php echo $title; ?></td>

        <td class="data"><span><?php echo $tr['date']; ?></span>
        <td class="data"><span><?php echo $tr['type']; ?></span>
        <td class="data"><span><?php echo $tr['amount']; ?></span>
        </td>

        </tr><?php } ?>
      </tbody></table><?php
    }
  }

}