'use strict';
document.addEventListener('DOMContentLoaded', () => {


  init_allCharts();


  function init_allCharts(){


    document.querySelectorAll('.dzs-chart.auto-init').forEach(($chart_)=>{
      init_chart($chart_);
    })
  }



  function init_chart($chart_) {

    google.charts.load('current', {'packages': ['corechart']});
    google.charts.setOnLoadCallback(drawChart);


    function drawChart() {
      var data = new google.visualization.DataTable();
      data.addColumn('date', 'Time of Day');
      data.addColumn('number', 'Points');
      try{

        const dataArr = JSON.parse($chart_.getAttribute('data-chart-info'));

        const rowData = dataArr.map((el)=>{ return [new Date(el.year, el.month, el.day), el.amount];});


        data.addRows(rowData)
        ;


        var options = {
          title: 'points progress',
          width: "100%",
          height: 500,
          backgroundColor: {
            fill: 'transparent',
            opacity: 0
          },
          hAxis: {
            format: 'M/d/yy',
            gridlines: {count: 15}
          },
          vAxis: {
            gridlines: {color: 'none'},
            minValue: 0
          }
        };

        var chart = new google.visualization.LineChart($chart_);

        chart.draw(data, options);
      }catch (e){

      }


    }
  }
}, false);