"use strict";
import {$es} from './js_common/_esjquery';

document.addEventListener("DOMContentLoaded", function() {

  $es(document).on('click', 'button[name="dzspsy_apply_all_points"]', handle_mouse);

  MutationObserver = window.MutationObserver || window.WebKitMutationObserver;


  function initCartTotalsListeners(){
    var _cartCon = null;

    const $cartCollaterals = document.getElementsByClassName('woocommerce');

    if($cartCollaterals.length){
      _cartCon = $cartCollaterals[0];
    }


    var observer = new MutationObserver(function(mutations, observer) {

      /**
       * observe for mutations on the cart ajax call
       */
      setTimeout(()=>{

        var __cartTotals = $es('.cart_totals');
        __cartTotals.find('th').$els.forEach((_el)=>{
          if(_el.textContent === 'user-points-lower-then-points' || _el.textContent === 'you-have-products-that-cannot-be-purchased-with-points'|| _el.textContent.toLowerCase() === 'subtotal-lower-then-points'){
            $es(_el).parent().attr('style', 'display: none;');

            if(_el.textContent==='user-points-lower-then-points'){
              $es('#dzspsy-ultibox--message-element').text('You do not have enough points for this purchase.');
            }
            if(_el.textContent==='subtotal-lower-then-points'){
              $es('#dzspsy-ultibox--message-element').text('Subtotal is lower then points you are trying to spend. Adjusting automatically ...');
            }
            if(_el.textContent==='you-have-products-that-cannot-be-purchased-with-points'){
              $es('#dzspsy-ultibox--message-element').text('You have products in cart that cannot be purchased with points.');
            }

            window.open_ultibox(jQuery(document.getElementById('dzspsy-ultibox-open-element')));

            setTimeout(()=>{
              if(!$es('.dzsulb-main-con').hasClass('disabled')){
                window.close_ultibox();
              }
            },5000);
          }
        })
      },10);

    });

    if(_cartCon){
      observer.observe(_cartCon, {attributes: false, childList: true, subtree: true})
    }
  }

  initCartTotalsListeners();


  /**
   *
   * @param {MouseEvent} e
   */
  function handle_mouse(e) {
    var _t = $es(this);

    if (e.type === 'click') {

      if(_t.attr('name')==='dzspsy_apply_all_points'){
        $es('button[name="update_cart"]').trigger('click');
        $es('.woocommerce-cart-form').trigger('submit');
      }

      e.preventDefault();

    }
  }
});